import { Input, Component, ViewContainerRef, ComponentFactoryResolver, SimpleChange, ChangeDetectorRef, ContentChildren, Injectable, EventEmitter, Output, NgModule } from '@angular/core';
import { FormGroup, ReactiveFormsModule, FormControl, FormArray } from '@angular/forms';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstract-form-field/abstract-form-field.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template T
 */
class AbstractFormFieldComponent {
}
AbstractFormFieldComponent.propDecorators = {
    formGroup: [{ type: Input }],
    element: [{ type: Input }],
    index: [{ type: Input }],
    fieldType: [{ type: Input }],
    path: [{ type: Input }],
    slots: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-type/abstract-type.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template T
 */
class AbstractType {
    /**
     * @param {?} options
     */
    constructor(options) {
        this.options = options;
    }
    /**
     * @return {?}
     */
    get asyncValidators() {
        return null;
    }
    /**
     * @return {?}
     */
    get validators() {
        return null;
    }
    /**
     * @return {?}
     */
    get updateOn() {
        return null;
    }
    /**
     * @return {?}
     */
    get disabled() {
        return false;
    }
    /**
     * @return {?}
     */
    get controlOptions() {
        return {
            asyncValidators: this.asyncValidators,
            validators: this.validators,
            updateOn: this.updateOn
        };
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-type/abstract-collection-type.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template TConfig, T
 */
class AbstractCollectionType extends AbstractType {
    // noinspection TypeScriptAbstractClassConstructorCanBeMadeProtected
    /**
     * @param {?} childType
     * @param {?} options
     */
    constructor(childType, options) {
        super(options);
        this.childType = childType;
        this.fieldInstance = new this.childType(this.options.entrySettings);
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-type/abstract-group-type.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template T
 */
class AbstractGroupType extends AbstractType {
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstraction/init-handler.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 */
class InitHandler {
    /**
     * @param {?} instance
     */
    constructor(instance) {
        this.instance = instance;
        this.propIsInitialized = false;
    }
    /**
     * @return {?}
     */
    get isInitialized() {
        return this.propIsInitialized;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    setIsInitialized(value) {
        /** @type {?} */
        const isGroupOrArray = 'controls' in this.instance;
        this.propIsInitialized = value;
        if (isGroupOrArray) {
            ((/** @type {?} */ ((/** @type {?} */ (this.instance)))))._setUpControls();
        }
        this.instance.updateValueAndValidity({ onlySelf: false, emitEvent: true });
        if (isGroupOrArray) {
            /** @type {?} */
            const childControls = ((/** @type {?} */ (this.instance))).controls;
            Object.keys(childControls)
                .forEach((/**
             * @param {?} k
             * @return {?}
             */
            (k) => childControls[k].initHandler.setIsInitialized(value)));
        }
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstraction/form-array.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormArray$1 extends FormArray {
    constructor() {
        super(...arguments);
        this.initHandler = new InitHandler(this);
    }
    /**
     * @param {?=} opts
     * @return {?}
     */
    updateValueAndValidity(opts) {
        if (this.initHandler && this.initHandler.isInitialized) {
            super.updateValueAndValidity(opts);
        }
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstraction/form-control.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormControl$1 extends FormControl {
    constructor() {
        super(...arguments);
        this.initHandler = new InitHandler(this);
    }
    /**
     * @param {?=} opts
     * @return {?}
     */
    updateValueAndValidity(opts) {
        if (this.initHandler && this.initHandler.isInitialized) {
            super.updateValueAndValidity(opts);
        }
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstraction/form-group.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormGroup$1 extends FormGroup {
    constructor() {
        super(...arguments);
        this.initHandler = new InitHandler(this);
    }
    /**
     * @param {?=} opts
     * @return {?}
     */
    updateValueAndValidity(opts) {
        if (this.initHandler && this.initHandler.isInitialized) {
            super.updateValueAndValidity(opts);
        }
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstraction/index.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-type/abstract-layout-type.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template T
 */
class AbstractLayoutType extends AbstractGroupType {
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/model-handler.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ModelHandler {
    /**
     * @param {?} model
     * @param {?} builderInstance
     * @return {?}
     */
    static build(model, builderInstance) {
        /** @type {?} */
        const group = new FormGroup$1({});
        this.handleModel(model, group, builderInstance);
        return group;
    }
    /**
     * @private
     * @param {?} model
     * @param {?} group
     * @param {?} builderInstance
     * @return {?}
     */
    static handleModel(model, group, builderInstance) {
        Object.keys(model).forEach((/**
         * @param {?} name
         * @return {?}
         */
        (name) => {
            /** @type {?} */
            const field = model[name];
            if (!field) {
                return;
            }
            if (field instanceof AbstractLayoutType) {
                this.handleModel(field.options.model, group, builderInstance);
                return;
            }
            /** @type {?} */
            const control = ModelHandler.buildSingleField(field, builderInstance);
            if (!control) {
                return;
            }
            control.setParent(group);
            if (field.disabled) {
                control.disable();
            }
            group.addControl(name, control);
            if (field.builderInstance == null && builderInstance) {
                field.builderInstance = builderInstance;
            }
            field.control = control;
        }));
    }
    /**
     * @param {?} field
     * @param {?} builderInstance
     * @return {?}
     */
    static buildSingleField(field, builderInstance) {
        /** @type {?} */
        let component;
        if (field instanceof AbstractCollectionType) {
            component = new FormArray$1([], field.controlOptions);
            ModelHandler.handleArray(field, component, builderInstance);
        }
        else if (field instanceof AbstractGroupType) {
            component = new FormGroup$1({}, field.controlOptions);
            ModelHandler.handleModel(field.options.model, component, builderInstance);
        }
        else if (field instanceof AbstractLayoutType) ;
        else if (field instanceof AbstractType) {
            component = new FormControl$1({ value: null, disabled: field.disabled }, field.controlOptions);
        }
        return component;
    }
    /**
     * @private
     * @param {?} field
     * @param {?} array
     * @param {?} builderInstance
     * @return {?}
     */
    static handleArray(field, array, builderInstance) {
        /** @type {?} */
        const control = ModelHandler.buildSingleField(field.fieldInstance, builderInstance);
        if (!control) {
            return;
        }
        array.push(control);
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstract-collection/abstract-collection.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// noinspection JSUnusedGlobalSymbols
/**
 * @abstract
 */
class AbstractCollectionComponent extends AbstractFormFieldComponent {
    // noinspection JSUnusedGlobalSymbols
    /**
     * @param {?} index
     * @return {?}
     */
    removeEntry(index) {
        this.element.removeAt(index);
    }
    // noinspection JSUnusedGlobalSymbols
    /**
     * @return {?}
     */
    addEntry() {
        /** @type {?} */
        const newControl = ModelHandler.buildSingleField(this.fieldType.fieldInstance, this.fieldType.builderInstance);
        if (!newControl) {
            return;
        }
        newControl.initHandler.setIsInitialized(true);
        this.element.controls.push(newControl);
    }
}
AbstractCollectionComponent.propDecorators = {
    element: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-slot/form-slot.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormSlotComponent {
    /**
     * @param {?} viewRef
     */
    constructor(viewRef) {
        this.viewRef = viewRef;
    }
}
FormSlotComponent.decorators = [
    { type: Component, args: [{
                selector: 'mw-form-slot',
                template: ''
            }] }
];
/** @nocollapse */
FormSlotComponent.ctorParameters = () => [
    { type: ViewContainerRef }
];
FormSlotComponent.propDecorators = {
    fieldName: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-field/form-field.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormFieldComponent extends AbstractFormFieldComponent {
    /**
     * @param {?} viewRef
     * @param {?} cfr
     */
    constructor(viewRef, cfr) {
        super();
        this.viewRef = viewRef;
        this.cfr = cfr;
    }
    // noinspection JSUnusedLocalSymbols
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        this.render();
    }
    /**
     * @return {?}
     */
    render() {
        if (this.fieldType == null) {
            return;
        }
        this.viewRef.clear();
        /** @type {?} */
        const factory = this.cfr.resolveComponentFactory(this.fieldType.component);
        /** @type {?} */
        const component = this.viewRef.createComponent(factory);
        /** @type {?} */
        const isGroup = this.fieldType instanceof AbstractGroupType;
        /** @type {?} */
        const changes = {
            formGroup: new SimpleChange(null, isGroup ? (/** @type {?} */ (this.element)) : this.formGroup, true),
            element: new SimpleChange(null, this.element, true),
            fieldType: new SimpleChange(null, this.fieldType, true),
            slots: new SimpleChange(null, this.slots, true),
            path: new SimpleChange(null, this.path, true),
            index: new SimpleChange(null, this.index, true),
        };
        component.instance.formGroup = changes.formGroup.currentValue;
        component.instance.element = changes.element.currentValue;
        component.instance.fieldType = changes.fieldType.currentValue;
        component.instance.slots = changes.slots.currentValue;
        component.instance.path = changes.path.currentValue;
        component.instance.index = changes.index.currentValue;
        if ('ngOnChanges' in component.instance) {
            ((/** @type {?} */ (component.instance))).ngOnChanges(changes);
        }
        component.changeDetectorRef.detectChanges();
    }
}
FormFieldComponent.decorators = [
    { type: Component, args: [{
                selector: 'mw-form-field',
                template: ''
            }] }
];
/** @nocollapse */
FormFieldComponent.ctorParameters = () => [
    { type: ViewContainerRef },
    { type: ComponentFactoryResolver }
];

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstract-form-group/abstract-form-group.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// noinspection JSUnusedGlobalSymbols
/**
 * @abstract
 * @template FormType
 */
class AbstractFormGroupComponent extends AbstractFormFieldComponent {
    /**
     * @param {?} cfr
     * @param {?} cdr
     */
    constructor(cfr, cdr) {
        super();
        this.cfr = cfr;
        this.cdr = cdr;
        this.groupPath = '';
        this.indexFromParent = null;
        this.fieldPaths = {};
        this.elements = {};
        this.isRootGroup = false;
        this.renderTargets = {};
        this.initializeTimeoutHandle = null;
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        /** @type {?} */
        const path = 'path' in changes ? changes.path.currentValue : this.path;
        if ('path' in changes) {
            this.groupPath = (path == null || path.trim() === '')
                ? ''
                : path;
        }
        /** @type {?} */
        const fieldType = 'fieldType' in changes ? changes.fieldType.currentValue : this.fieldType;
        if ('path' in changes || 'fieldType' in changes) {
            this.fieldPaths = Object.keys(fieldType.options.model).reduce((/**
             * @param {?} all
             * @param {?} fieldName
             * @return {?}
             */
            (all, fieldName) => {
                if (fieldType.options.model[fieldName] instanceof AbstractLayoutType) {
                    all[fieldName] = path;
                }
                else {
                    all[fieldName] = (this.groupPath !== '' ? this.groupPath + '.' : '') + fieldName;
                }
                return all;
            }), {});
        }
        if ('index' in changes) {
            /** @type {?} */
            const index = changes.index.currentValue;
            this.indexFromParent = null;
            if (index != null) {
                /** @type {?} */
                let p = this.element;
                do {
                    p = p.parent;
                    if (p instanceof FormArray$1) {
                        this.indexFromParent = this.index;
                        break;
                    }
                } while (p && p.parent && !(parent instanceof FormControl$1));
            }
        }
        this.elements = Object.keys(fieldType.options.model).reduce((/**
         * @param {?} all
         * @param {?} fieldName
         * @return {?}
         */
        (all, fieldName) => {
            if (fieldType.options.model[fieldName] instanceof AbstractLayoutType) {
                all[fieldName] = this.element;
            }
            else {
                all[fieldName] = this.element.get(fieldName);
            }
            return all;
        }), {});
        /** @type {?} */
        let wasRendered = false;
        if ('slots' in changes && changes.slots.currentValue) {
            this.renderElementsInSlots();
            wasRendered = true;
        }
        if (!wasRendered && 'mySlots' in changes && changes.mySlots.currentValue) {
            this.renderElementsInSlots();
        }
    }
    /**
     * @return {?}
     */
    ngAfterContentInit() {
        if (this.mySlots) {
            this.renderElementsInSlots();
            this.cdr.detectChanges();
        }
    }
    /**
     * @private
     * @return {?}
     */
    renderElementsInSlots() {
        if (this.slots || this.mySlots) {
            this.createRenderTargets();
            Object.keys(this.renderTargets).map((/**
             * @param {?} name
             * @return {?}
             */
            (name) => {
                if (!(name in this.renderTargets)) {
                    return;
                }
                this.renderTargets[name].viewRef.clear();
                /** @type {?} */
                const factory = this.cfr.resolveComponentFactory(FormFieldComponent);
                /** @type {?} */
                const target = this.renderTargets[name].viewRef.createComponent(factory);
                target.instance.formGroup = this.formGroup;
                target.instance.element = this.formGroup.get(name);
                target.instance.slots = this.slots;
                target.instance.path = this.fieldPaths[name];
                target.instance.fieldType = this.fieldType.options.model[name];
                target.instance.index = this.indexFromParent;
                target.instance.render();
            }));
            if (this.isRootGroup) {
                if (this.initializeTimeoutHandle) {
                    window.clearTimeout(this.initializeTimeoutHandle);
                }
                this.initializeTimeoutHandle = window.setTimeout((/**
                 * @return {?}
                 */
                () => {
                    this.element.initHandler.setIsInitialized(true);
                    this.cdr.detectChanges();
                }), 5);
            }
        }
    }
    /**
     * @private
     * @return {?}
     */
    createRenderTargets() {
        /** @type {?} */
        const groupPath = this.groupPath;
        if (this.slots) {
            this.slots.toArray().forEach((/**
             * @param {?} slot
             * @return {?}
             */
            (slot) => {
                if (slot.fieldName.substr(0, groupPath.length) !== groupPath) {
                    return;
                }
                /** @type {?} */
                let name = slot.fieldName.substr(groupPath.length, slot.fieldName.length - groupPath.length);
                if (name.startsWith('.')) {
                    name = name.substr(1);
                }
                if (name.indexOf('.') < 0 && name !== '') {
                    this.renderTargets[name] = slot;
                }
            }));
        }
        if (this.mySlots) {
            this.mySlots.toArray().forEach((/**
             * @param {?} slot
             * @return {?}
             */
            (slot) => {
                this.renderTargets[slot.fieldName] = slot;
            }));
        }
    }
    // noinspection JSUnusedGlobalSymbols
    /**
     * @param {?} a
     * @param {?} b
     * @return {?}
     */
    orderAsGiven(a, b) {
        return a || b ? 1 : 0;
    }
}
AbstractFormGroupComponent.decorators = [
    { type: Injectable }
];
/** @nocollapse */
AbstractFormGroupComponent.ctorParameters = () => [
    { type: ComponentFactoryResolver },
    { type: ChangeDetectorRef }
];
AbstractFormGroupComponent.propDecorators = {
    element: [{ type: Input }],
    isRootGroup: [{ type: Input }],
    mySlots: [{ type: ContentChildren, args: [FormSlotComponent, { descendants: true },] }]
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstract-layout/abstract-layout.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// noinspection JSUnusedGlobalSymbols
/**
 * @abstract
 * @template FormType
 */
class AbstractLayoutComponent extends AbstractFormGroupComponent {
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-group/form-group.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormGroupType extends AbstractGroupType {
    constructor() {
        super(...arguments);
        this.component = FormGroupComponent;
    }
}
class FormGroupComponent extends AbstractFormGroupComponent {
}
FormGroupComponent.decorators = [
    { type: Component, args: [{
                selector: 'mw-form-group',
                template: `
    <ng-content></ng-content>
    <ng-container *ngFor="let field of fieldType.options.model | keyvalue:orderAsGiven">
      <mw-form-field *ngIf="renderTargets[field.key] == null"
                     [formGroup]="element"
                     [element]="elements[field.key]"
                     [fieldType]="field.value"
                     [path]="fieldPaths[field.key]"
                     [index]="indexFromParent"
                     [slots]="slots">
      </mw-form-field>
    </ng-container>
  `
            }] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-builder/form-builder.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 */
class FormBuilderComponent {
    constructor() {
        this.onSubmit = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        if (this.group == null) {
            this.rebuildForm();
        }
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        if ('formModel' in changes && changes.formModel.currentValue) {
            this.rebuildForm();
            this.fieldType = new FormGroupType({
                model: this.formModel,
            });
            Object.assign(this.fieldType, {
                builderInstance: this,
                component: FormGroupComponent,
                control: this.group,
            });
        }
        if ('formData' in changes && changes.formData.currentValue) {
            if (!('formModel' in changes)) {
                this.initializeCollectionFields(this.group, this.formModel, this.formData);
                this.group.initHandler.setIsInitialized(false);
                this.group.initHandler.setIsInitialized(true);
            }
            if (this.group) {
                this.group.patchValue(this.formData);
            }
        }
    }
    /**
     * @return {?}
     */
    rebuildForm() {
        /** @type {?} */
        let res = null;
        /** @type {?} */
        let groupIsInitialized = false;
        if (this.group) {
            res = Object.assign({}, this.group.value);
            groupIsInitialized = this.group.initHandler.isInitialized;
        }
        else if (this.formData) {
            res = Object.assign({}, this.formData);
        }
        this.group = ModelHandler.build(this.formModel, this);
        this.initializeCollectionFields(this.group, this.formModel, res);
        if (this.group && res) {
            if (groupIsInitialized) {
                this.group.initHandler.setIsInitialized(true);
            }
            this.group.patchValue(res);
        }
    }
    /**
     * @private
     * @param {?} group
     * @param {?} model
     * @param {?} data
     * @return {?}
     */
    initializeCollectionFields(group, model, data) {
        Object.keys(model).forEach((/**
         * @param {?} name
         * @return {?}
         */
        (name) => {
            /** @type {?} */
            const formType = model[name];
            /** @type {?} */
            const childData = (data && name in data) ? data[name] : null;
            /** @type {?} */
            const control = group.get(name);
            if (formType instanceof AbstractGroupType && control instanceof FormGroup$1) {
                this.initializeCollectionFields(control, formType.options.model, childData);
            }
            else if (formType instanceof AbstractLayoutType) {
                this.initializeCollectionFields(group, formType.options.model, data);
            }
            else if (formType instanceof AbstractCollectionType && control instanceof FormArray$1) {
                this.initializeCollectionField(formType, control, childData);
            }
        }));
    }
    /**
     * @private
     * @param {?} collection
     * @param {?} array
     * @param {?=} data
     * @return {?}
     */
    initializeCollectionField(collection, array, data) {
        /** @type {?} */
        const numberOfEntries = Array.isArray(data) ? data.length : 0;
        array.controls.splice(0, array.controls.length);
        if (numberOfEntries === 0) {
            return;
        }
        /** @type {?} */
        const fieldInstance = collection.fieldInstance;
        for (let i = 0; i < numberOfEntries; i++) {
            /** @type {?} */
            const control = ModelHandler.buildSingleField(fieldInstance, this);
            if (!control) {
                continue;
            }
            if (fieldInstance instanceof AbstractGroupType && control instanceof FormGroup$1) {
                control.setParent(array);
                if (fieldInstance.disabled) {
                    control.disable();
                }
                this.initializeCollectionFields(control, fieldInstance.options.model, data[i]);
            }
            else if (fieldInstance instanceof AbstractCollectionType && control instanceof FormArray$1) {
                control.setParent(array);
                if (fieldInstance.disabled) {
                    control.disable();
                }
                this.initializeCollectionField(fieldInstance, control, data[i]);
            }
            array.controls.push(control);
        }
    }
    /**
     * @return {?}
     */
    submit() {
        Object.keys(this.group.controls).forEach((/**
         * @param {?} field
         * @return {?}
         */
        (field) => {
            /** @type {?} */
            const control = this.group.get(field);
            control.markAsDirty();
            control.updateValueAndValidity();
        }));
        if (!this.group.valid) {
            return;
        }
        this.onSubmit.emit(this.group.value);
        return this.group.value;
    }
    /**
     * @param {?=} group
     * @return {?}
     */
    getErrors(group) {
        /** @type {?} */
        const errors = group instanceof FormArray$1 ? [] : {};
        if (group == null) {
            group = this.group;
        }
        /** @type {?} */
        let idx = 0;
        Object.keys(group.controls).forEach((/**
         * @param {?} name
         * @return {?}
         */
        (name) => {
            idx++;
            /** @type {?} */
            const control = group.get(name);
            if (control instanceof FormArray$1 || control instanceof FormGroup$1) {
                /** @type {?} */
                const tmpErrors = this.getErrors(control);
                if (tmpErrors) {
                    errors[name] = tmpErrors;
                }
            }
            else if (control instanceof FormControl$1) {
                if (control.errors == null) {
                    return null;
                }
                if (group instanceof FormArray$1) {
                    ((/** @type {?} */ (errors)))[idx] = control.errors;
                }
                else {
                    errors[name] = control.errors;
                }
            }
        }));
        return (group instanceof FormGroup$1 && Object.keys(errors).length === 0)
            || Array.isArray(errors) && errors.length === 0 ? null : errors;
    }
}
FormBuilderComponent.decorators = [
    { type: Component, args: [{
                selector: 'mw-form-builder',
                template: `
    <ng-content></ng-content>
    <form [formGroup]="group" (ngSubmit)="submit()">
      <mw-form-group [element]="group"
                     [formGroup]="group"
                     [fieldType]="fieldType"
                     [slots]="slots"
                     [isRootGroup]="true">
      </mw-form-group>
    </form>
  `
            }] }
];
FormBuilderComponent.propDecorators = {
    formModel: [{ type: Input }],
    formData: [{ type: Input }],
    onSubmit: [{ type: Output }],
    slots: [{ type: ContentChildren, args: [FormSlotComponent, { descendants: true },] }]
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-builder.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormBuilderModule {
}
FormBuilderModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    FormBuilderComponent,
                    FormGroupComponent,
                    FormFieldComponent,
                    FormSlotComponent,
                ],
                entryComponents: [
                    FormFieldComponent,
                    FormGroupComponent,
                ],
                imports: [
                    ReactiveFormsModule,
                    CommonModule,
                ],
                exports: [
                    FormBuilderComponent,
                    FormGroupComponent,
                    FormFieldComponent,
                    FormSlotComponent,
                ],
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: lib/types.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: mw-form-builder.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AbstractCollectionComponent, AbstractFormFieldComponent, AbstractFormGroupComponent, AbstractLayoutComponent, FormBuilderComponent, FormFieldComponent, FormSlotComponent, FormBuilderModule, AbstractGroupType, AbstractCollectionType, AbstractLayoutType, AbstractType, FormGroupComponent as ɵa };

//# sourceMappingURL=mw-form-builder.js.map